import {select,csv,scaleLinear,max,scaleBand,axisLeft,axisBottom,format} from 'd3';

const titleText = 'iris dataset';
const xAxisLabelText = 'sepal length';
const yAxisLabelText= 'petal length';

const svg = select('svg');

const width = +svg.attr('width');
const height = +svg.attr('height');

const render = data => {
  const xValue = d => d['sepal_length'];
  const yValue = d => d['petal.length'];
  const margin = { top: 60, right: 80, bottom: 70, left: 155};
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;
  
  const xScale = scaleLinear()
				.domain([4, max(data, xValue)])
          .range([0,innerWidth]);
  
  const yScale =  scaleLinear()
    .domain([0, max(data, yValue)])
    .range([innerHeight,0]);
       
  
  const g = svg.append('g')
    .attr('transform', `translate(${margin.left},${margin.top})`);
 /*  g.append('g').call(axisLeft(yScale));
  g.append('g').call(axisBottom(xScale))
    .attr('transform', `translate(0,${innerHeight})`);*/
  const xAxisTickFormat = number =>
    format('.3s')(number)
      .replace('G', 'B');
  
  const xAxis = axisBottom(xScale)
    .tickFormat(xAxisTickFormat)
    .tickSize(-innerHeight);
  const yAxis=axisLeft(yScale)
  	 .tickSize(-innerWidth);
  g.append('g')
    .call(yAxis)
    .selectAll('.domain')
      .remove();
  
  const xAxisG = g.append('g').call(xAxis)
    .attr('transform', `translate(0,${innerHeight})`);
  
  xAxisG.select('.domain').remove();
  
  xAxisG.append('text')
      .attr('class', 'axis-label')
      .attr('y', 65)
      .attr('x', innerWidth / 2)
      .attr('fill', 'black')
      .text(xAxisLabelText);
  
const yAxisG = g.append('g');
      const colorLegendG = g.append('g')
          .attr('transform', `translate(${innerWidth + 60}, 150)`);
    yAxisG.append('text')
      .attr('class', 'axis-label')
      .attr('x', innerHeight/2)
      .attr('y', 50)
      .attr('fill', 'black')
      .attr('transform', `rotate(-90)`)
      .style('text-anchor', 'middle')
       .text(yAxisLabelText);
  
  g.selectAll('circle').data(data)
    .enter().append('circle')
      .attr('cy', d => yScale(yValue(d)) )
      .attr('cx', d => xScale(xValue(d)))
      .attr('r', 8)
    .style("fill", function (d) { return color(d.variety) } );
  
  g.append('text')
      .attr('class', 'title')
      .attr('y', -10)
      .text(titleText);
};
  var color = d3.scaleOrdinal()
    .domain(["setosa", "versicolor", "virginica" ])
    .range([ "#440154ff", "#21908dff", "#fde725ff"])
csv('data.csv').then(data => {
   data.forEach(d =>{
    d.sepal_length = +d.sepal_length;
    d.sepal_width  = +d.sepal_width;

  });
  render(data);
});
